# Generated by Django 3.2.4 on 2021-07-12 13:10

import django.db.models.deletion
from django.db import migrations, models

import drf_kit.models
import test_app.storage


class Migration(migrations.Migration):
    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="House",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True, verbose_name="created at")),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="updated at")),
                ("name", models.CharField(max_length=50)),
                ("points_boost", models.DecimalField(decimal_places=2, default=1.0, max_digits=4)),
            ],
            options={
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=(drf_kit.models.ModelDiffMixin, drf_kit.models.BoundedFileMixin, models.Model),
        ),
        migrations.CreateModel(
            name="Spell",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True, verbose_name="created at")),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="updated at")),
                ("type", models.CharField(max_length=100)),
                ("name", models.CharField(max_length=50)),
            ],
            options={
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=(drf_kit.models.ModelDiffMixin, drf_kit.models.BoundedFileMixin, models.Model),
        ),
        migrations.CreateModel(
            name="SpellCast",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True, verbose_name="created at")),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="updated at")),
                ("is_successful", models.BooleanField(default=True)),
                (
                    "spell",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="spell_casts",
                        to="test_app.spell",
                    ),
                ),
            ],
            options={
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=(drf_kit.models.ModelDiffMixin, drf_kit.models.BoundedFileMixin, models.Model),
        ),
        migrations.CreateModel(
            name="Wizard",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True, verbose_name="created at")),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="updated at")),
                ("name", models.CharField(max_length=50)),
                ("age", models.IntegerField(blank=True, null=True)),
                ("is_half_blood", models.BooleanField(default=True)),
                (
                    "picture",
                    models.FileField(blank=True, null=True, upload_to=test_app.storage.StoragePath._media_thumb_upload),
                ),
                (
                    "extra_picture",
                    models.FileField(
                        blank=True,
                        null=True,
                        upload_to=test_app.storage.StoragePath._preserve_name_upload,
                    ),
                ),
                ("received_letter_at", models.DateTimeField(blank=True, null=True)),
                (
                    "house",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="wizards",
                        to="test_app.house",
                    ),
                ),
                (
                    "spells",
                    models.ManyToManyField(related_name="wizards", through="test_app.SpellCast", to="test_app.Spell"),
                ),
            ],
            options={
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=(drf_kit.models.ModelDiffMixin, drf_kit.models.BoundedFileMixin, models.Model),
        ),
        migrations.CreateModel(
            name="CombatSpell",
            fields=[
                (
                    "spell_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="test_app.spell",
                    ),
                ),
                ("is_attack", models.BooleanField(default=True)),
            ],
            options={
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=("test_app.spell",),
        ),
        migrations.CreateModel(
            name="EnvironmentalSpell",
            fields=[
                (
                    "spell_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="test_app.spell",
                    ),
                ),
            ],
            options={
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=("test_app.spell",),
        ),
        migrations.CreateModel(
            name="Teacher",
            fields=[
                (
                    "wizard_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="test_app.wizard",
                    ),
                ),
                ("is_ghost", models.BooleanField(default=False)),
            ],
            options={
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=("test_app.wizard",),
        ),
        migrations.CreateModel(
            name="Wand",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True, verbose_name="created at")),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="updated at")),
                ("name", models.CharField(max_length=50)),
                (
                    "holder",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="wands",
                        to="test_app.wizard",
                    ),
                ),
            ],
            options={
                "verbose_name": "varinha",
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=(drf_kit.models.ModelDiffMixin, drf_kit.models.BoundedFileMixin, models.Model),
        ),
        migrations.CreateModel(
            name="TriWizardPlacement",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True, verbose_name="created at")),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="updated at")),
                (
                    "order",
                    models.PositiveIntegerField(
                        blank=True,
                        db_index=True,
                        default=None,
                        null=True,
                        verbose_name="order",
                    ),
                ),
                ("year", models.IntegerField()),
                ("prize", models.CharField(max_length=100)),
                (
                    "wizard",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="placements",
                        to="test_app.wizard",
                    ),
                ),
            ],
            options={
                "ordering": ["year", "order"],
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=(drf_kit.models.ModelDiffMixin, drf_kit.models.BoundedFileMixin, models.Model),
        ),
        migrations.AddField(
            model_name="spellcast",
            name="wizard",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="spell_casts",
                to="test_app.wizard",
            ),
        ),
        migrations.CreateModel(
            name="Patronus",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True, verbose_name="created at")),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="updated at")),
                ("name", models.CharField(max_length=50)),
                ("color", models.CharField(max_length=50, null=True)),
                ("wizard", models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to="test_app.wizard")),
            ],
            options={
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=(drf_kit.models.ModelDiffMixin, drf_kit.models.BoundedFileMixin, models.Model),
        ),
        migrations.CreateModel(
            name="Memory",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True, verbose_name="created at")),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="updated at")),
                ("deleted_at", models.DateTimeField(blank=True, default=None, null=True, verbose_name="deleted at")),
                ("description", models.TextField()),
                (
                    "owner",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="memories",
                        to="test_app.wizard",
                    ),
                ),
            ],
            options={
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=(drf_kit.models.ModelDiffMixin, drf_kit.models.BoundedFileMixin, models.Model),
        ),
        migrations.AddIndex(
            model_name="house",
            index=models.Index(fields=["updated_at"], name="test_app_ho_updated_5112f6_idx"),
        ),
        migrations.AddIndex(
            model_name="wizard",
            index=models.Index(fields=["updated_at"], name="test_app_wi_updated_17f11a_idx"),
        ),
        migrations.AddIndex(
            model_name="wand",
            index=models.Index(fields=["updated_at"], name="test_app_wa_updated_42e08c_idx"),
        ),
        migrations.AddIndex(
            model_name="triwizardplacement",
            index=models.Index(fields=["updated_at"], name="test_app_tr_updated_69f4a5_idx"),
        ),
        migrations.AddConstraint(
            model_name="triwizardplacement",
            constraint=models.UniqueConstraint(fields=("wizard", "year"), name="unique_wizard"),
        ),
        migrations.AddConstraint(
            model_name="triwizardplacement",
            constraint=models.UniqueConstraint(fields=("prize",), name="unique_prize"),
        ),
        migrations.AddIndex(
            model_name="spellcast",
            index=models.Index(fields=["updated_at"], name="test_app_sp_updated_2c072e_idx"),
        ),
        migrations.AddIndex(
            model_name="patronus",
            index=models.Index(fields=["updated_at"], name="test_app_pa_updated_5c8496_idx"),
        ),
        migrations.AddIndex(
            model_name="memory",
            index=models.Index(fields=["updated_at"], name="test_app_me_updated_b9a95b_idx"),
        ),
        migrations.AddIndex(
            model_name="memory",
            index=models.Index(fields=["deleted_at"], name="test_app_me_deleted_c823f5_idx"),
        ),
    ]
