# Generated by Django 4.1 on 2022-08-19 12:15

import django.db.models.deletion
from django.db import migrations, models

import drf_kit.models.diff_models
import drf_kit.models.file_models


class Migration(migrations.Migration):
    dependencies = [
        ("test_app", "0003_patronus_memory_alter_patronus_color"),
    ]

    operations = [
        migrations.CreateModel(
            name="Newspaper",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True, verbose_name="created at")),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="updated at")),
                ("starts_at", models.DateTimeField(blank=True, default=None, null=True, verbose_name="starts at")),
                ("ends_at", models.DateTimeField(blank=True, default=None, null=True, verbose_name="ends at")),
                ("deleted_at", models.DateTimeField(blank=True, default=None, null=True, verbose_name="deleted at")),
                ("headline", models.CharField(default="?", max_length=30)),
            ],
            options={
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=(
                drf_kit.models.diff_models.ModelDiffMixin,
                drf_kit.models.file_models.BoundedFileMixin,
                models.Model,
            ),
        ),
        migrations.CreateModel(
            name="RoomOfRequirement",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True, verbose_name="created at")),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="updated at")),
                ("starts_at", models.DateTimeField(blank=True, default=None, null=True, verbose_name="starts at")),
                ("ends_at", models.DateTimeField(blank=True, default=None, null=True, verbose_name="ends at")),
                (
                    "wizard",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="test_app.wizard",
                    ),
                ),
            ],
            options={
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=(
                drf_kit.models.diff_models.ModelDiffMixin,
                drf_kit.models.file_models.BoundedFileMixin,
                models.Model,
            ),
        ),
        migrations.AddIndex(
            model_name="newspaper",
            index=models.Index(fields=["deleted_at"], name="test_app_ne_deleted_b41253_idx"),
        ),
        migrations.AddIndex(
            model_name="newspaper",
            index=models.Index(fields=["starts_at"], name="test_app_ne_starts__c96851_idx"),
        ),
        migrations.AddIndex(
            model_name="newspaper",
            index=models.Index(fields=["ends_at"], name="test_app_ne_ends_at_2c58c7_idx"),
        ),
        migrations.AddIndex(
            model_name="newspaper",
            index=models.Index(fields=["updated_at"], name="test_app_ne_updated_ec3909_idx"),
        ),
        migrations.AddConstraint(
            model_name="newspaper",
            constraint=models.CheckConstraint(
                check=models.Q(("starts_at__lte", models.F("ends_at"))),
                name="newspaper_invalid_date_range",
            ),
        ),
        migrations.AddIndex(
            model_name="roomofrequirement",
            index=models.Index(fields=["updated_at"], name="test_app_ro_updated_99ce38_idx"),
        ),
        migrations.AddIndex(
            model_name="roomofrequirement",
            index=models.Index(fields=["starts_at"], name="test_app_ro_starts__fa41b5_idx"),
        ),
        migrations.AddIndex(
            model_name="roomofrequirement",
            index=models.Index(fields=["ends_at"], name="test_app_ro_ends_at_084da4_idx"),
        ),
        migrations.AddConstraint(
            model_name="roomofrequirement",
            constraint=models.CheckConstraint(
                check=models.Q(("starts_at__lte", models.F("ends_at"))),
                name="roomofrequirement_invalid_date_range",
            ),
        ),
    ]
