# Generated by Django 4.1.7 on 2023-04-17 18:12

from django.db import migrations, models

import drf_kit.models.diff_models
import drf_kit.models.file_models


class Migration(migrations.Migration):
    dependencies = [
        ("test_app", "0006_news_exclusivenews_exclusivearticle_and_more"),
    ]

    operations = [
        migrations.CreateModel(
            name="Beast",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True, verbose_name="created at")),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="updated at")),
                ("deleted_at", models.DateTimeField(blank=True, default=None, null=True, verbose_name="deleted at")),
                ("name", models.CharField(max_length=100)),
                ("age", models.IntegerField()),
            ],
            options={
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
            },
            bases=(
                drf_kit.models.diff_models.ModelDiffMixin,
                drf_kit.models.file_models.BoundedFileMixin,
                models.Model,
            ),
        ),
        migrations.AddIndex(
            model_name="beast",
            index=models.Index(fields=["updated_at"], name="test_app_be_updated_682cc9_idx"),
        ),
        migrations.AddConstraint(
            model_name="beast",
            constraint=models.UniqueConstraint(fields=("name", "age"), name="single-beast-per-year"),
        ),
        migrations.AddConstraint(
            model_name="beast",
            constraint=models.CheckConstraint(check=models.Q(("age__gte", 0)), name="minimum-beast-age"),
        ),
    ]
