# Generated by Django 5.0.5 on 2024-05-07 14:19

import django.contrib.postgres.constraints
import django.contrib.postgres.fields.ranges
import django.db.models.deletion
from django.contrib.postgres.operations import BtreeGistExtension
from django.db import migrations, models

import drf_kit.models.diff_models
import drf_kit.models.file_models


class Migration(migrations.Migration):
    dependencies = [
        ("test_app", "0010_exclusivearticle_slug_alter_beast_category"),
    ]

    operations = [
        BtreeGistExtension(),
        migrations.CreateModel(
            name="TrainingPitch",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True, verbose_name="created at")),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="updated at")),
                ("name", models.CharField(max_length=100)),
            ],
            options={
                "ordering": ("-updated_at",),
                "get_latest_by": "updated_at",
                "abstract": False,
                "indexes": [models.Index(fields=["updated_at"], name="test_app_tr_updated_a1fc36_idx")],
            },
            bases=(
                drf_kit.models.diff_models.ModelDiffMixin,
                drf_kit.models.file_models.BoundedFileMixin,
                models.Model,
            ),
        ),
        migrations.CreateModel(
            name="Reservation",
            fields=[
                ("id", models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True, verbose_name="created at")),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="updated at")),
                ("period", django.contrib.postgres.fields.ranges.DateTimeRangeField()),
                (
                    "wizard",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, related_name="reservations", to="test_app.wizard"
                    ),
                ),
                (
                    "pitch",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="reservations",
                        to="test_app.trainingpitch",
                    ),
                ),
            ],
            bases=(
                drf_kit.models.diff_models.ModelDiffMixin,
                drf_kit.models.file_models.BoundedFileMixin,
                models.Model,
            ),
        ),
        migrations.AddConstraint(
            model_name="reservation",
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(
                expressions=[("period", "&&"), ("pitch_id", "=")], name="exclude_overlapping_reservations"
            ),
        ),
    ]
